import 'package:m4e_sdk/m4e_sdk.dart';

class TransactionService {
  final _transactionService = M4eTransactionService();

  Future<M4eTransactionList> getUserTransactions(M4eUniqueId userId) async {
    try {
      final _transactions =
          await _transactionService.getUserTransactions(userId);

      return _transactions;
    } on M4eServerException catch (e) {
      throw e;
    }
  }

  Future<M4eTransactionResult> createTransactions(
      M4eUniqueId userId, M4eTransactionForm transactionForm) async {
    try {
      final _transactionResult = await _transactionService.initiateTransaction(
          userId, transactionForm);

      return _transactionResult;
    } on M4eServerException catch (e) {
      throw e;
    }
  }
}
