import 'package:dio/dio.dart';

class M4eLoggingInterceptors extends InterceptorsWrapper {
  @override
  Future onRequest(RequestOptions options) async {
    print(
        '--> ${options.method != null ? options.method.toUpperCase() : 'METHOD'} ${'' + (options.baseUrl ?? '') + (options.path ?? '')}');
    print('<-- End Request');
    return options;
  }

  @override
  Future onResponse(Response response) {
    print(
        '<-- ${response.statusCode} ${(response.request != null ? (response.request.baseUrl + response.request.path) : 'URL')}');

    print('<-- END Response');
    return super.onResponse(response);
  }

  @override
  Future onError(DioError dioError) async {
    print(
        '<-- ${dioError.message} ${(dioError.response?.request != null ? (dioError.response.request.baseUrl + dioError.response.request.path) : 'URL')}');
    print(
        '${dioError.response != null ? dioError.response.data : 'Unknown Error'}');
    print('<-- End error');

    return super.onError(dioError);
  }
}
