import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../../core/core.dart';
import '../../models/models.dart';

class M4ePermissionForm extends Equatable {
  final M4eUniqueId subId;
  final M4eUniqueId objId;
  final M4eAccessPermissionType type;
  final List<M4eAccessPermissionSet> encoding;

  const M4ePermissionForm({
    @required M4eUniqueId subId,
    @required M4eUniqueId objId,
    @required M4eAccessPermissionType type,
    @required List<M4eAccessPermissionSet> encoding,
  })  :
        // assert(subId != null, 'M4ePermissionForm [subId] should not be null'),
        //       assert(objId != null, 'M4ePermissionForm [objId] should not be null'),
        //       assert(type != null, 'M4ePermissionForm [type] should not be null'),
        //       assert(encoding != null,
        //           'M4ePermissionForm [encoding] should not be null'),
        this.subId = subId,
        this.objId = objId,
        this.type = type,
        this.encoding = encoding;

  Map<String, dynamic> toJson() {
    return {
      'subId': this.subId.toString(),
      'objId': this.objId.toString(),
      'accessEncoding': {
        'type': this.type.toString(),
        'encoding': encoding?.map((e) => e.toString())?.toList() ?? []
      }
    };
  }

  @override
  List<Object> get props => [subId, objId, type, encoding];

  @override
  String toString() {
    return 'M4ePermissionForm(subId: $subId, objId: $objId, type: $type, encoding: ${encoding.toString()})';
  }
}
