import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../../core/core.dart';
import '../../models/models.dart';

class M4eWalletForm extends Equatable {
  final M4eUniqueId id;
  final String label;
  final M4eCurrencyType currency;
  final M4eWalletType type;
  final M4eWalletDetailType detail;

  const M4eWalletForm({
    @required M4eUniqueId id,
    @required String label,
    @required M4eCurrencyType currency,
    @required M4eWalletType type,
    @required M4eWalletDetailType detail,
  })  : assert(id != null, 'M4eWalletForm [id] should not be null'),
        assert(label != null, 'M4eWalletForm [label] should not be null'),
        assert(currency != null, 'M4eWalletForm [currency] should not be null'),
        assert(type != null, 'M4eWalletForm [type] should not be null'),
        assert(detail != null, 'M4eWalletForm [detail] should not be null'),
        this.id = id,
        this.label = label,
        this.currency = currency,
        this.type = type,
        this.detail = detail;

  // factory M4eWalletForm.fromJson(Map<String, dynamic> json) {
  //   return M4eWalletForm._(
  //     M4eUniqueId.fromUniqueString(json['id']),
  //     json['wallet']['label'],
  //     M4eCurrencyType.parse(json['wallet']['currency']),
  //     M4eWalletType.parse(json['wallet']['type']),
  //     M4eWalletDetailType.fromJson(json['detail']),
  //   );
  // }

  Map<String, dynamic> toJson() {
    return {
      'id': this.id.toString(),
      'wallet': {
        'label': this.label,
        'currency': this.currency.toString(),
        'type': this.type.toString(),
      },
      'detail': this.detail.map(
            m4eWalletDetail: (detail) => detail.toJson(),
            mobileMoneyWalletDetail: (detail) => detail.toJson(),
          ),
    };
  }

  @override
  List<Object> get props {
    return [
      id,
      label,
      currency,
      type,
      detail,
    ];
  }

  @override
  String toString() {
    return 'M4eWalletForm(id: $id, label: $label, currency: $currency, type: $type, detail: $detail)';
  }
}
