import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import 'models.dart';

class M4eAmount extends Equatable {
  final double value;
  final M4eCurrencyType currency;

  const M4eAmount({@required double value, @required M4eCurrencyType currency})
      : assert(value != null, 'M4eAmount [value] should not be null'),
        assert(currency != null, 'M4eAmount [currency] should not be null'),
        this.value = value,
        this.currency = currency;

  factory M4eAmount.fromJson(Map<String, dynamic> json) {
    return M4eAmount(
      value: json['value'],
      currency: M4eCurrencyType.parse(json['unit']),
    );
  }

  Map<String, dynamic> toJson() {
    return {
      'value': this.value,
      'unit': this.currency.toString(),
    };
  }

  @override
  List<Object> get props => [
        value,
        currency,
      ];

  @override
  String toString() =>
      'M4eAmount(value: $value, currency: ${currency.toString()})';
}
